<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*
* CLASS DESCRIPTION
*                   
* ps_function_reg
*
* The class is is used to manage the function register.
* 
* propeties:  
* 	
*       error - the error message returned by validation if any
* methods:
*       validate_add()
*	validate_delete()
*	validate_update()
*       add()
*       update()
*       delete()
*	
*
*************************************************************************/
class ps_function_reg {
  var $classname = "ps_function_reg";
  var $error;
 

  /**************************************************************************
  ** name: validate_add
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/ 
  function validate_add($d) {
    
    $db = new ps_DB;
    
    if (!$d["function_name"]) {
      $this->error = "ERROR:  You must enter a name for the function.";
      return False;	
    }
    if (!$d["function_class"]) {
      $this->error = "ERROR:  You must enter a name for the class.";
      return False;	
    }
    if (!$d["function_method"]) {
      $this->error = "ERROR:  You must enter a name for the method.";
      return False;	
    }
    if (!$d["function_perms"]) {
      $this->error = "ERROR:  You must enter a permissions for the method.";
      return False;	
    }
    if ($d["function_name"]) {
      $q = "SELECT count(*) as rowcnt from function where";
      $q .= " function_name='" .  $d["function_name"] . "'";
      $db->query($q);
      $db->next_record();
      if ($db->f("rowcnt") > 0) {
	$this->error = "The given function name already exists.";
	return False;
      }      
    }
    return True;    
  }
  
  /**************************************************************************
  ** name: validate_delete()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/   function validate_delete($d) {
    
    if (!$d["function_id"]) {
      $this->error = "ERROR:  Please select a function to delete.";
      return False;
    }
    else {
      return True;
    }
  }
  
  /**************************************************************************
  ** name: validate_update
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/   function validate_update($d) {
    
    if (!$d["function_name"]) {
      $this->error = "ERROR:  You must enter a name for the function.";
      return False;	
    }
    if (!$d["function_class"]) {
      $this->error = "ERROR:  You must enter a name for the class.";
      return False;	
    }
    if (!$d["function_method"]) {
      $this->error = "ERROR:  You must enter a name for the method.";
      return False;	
    }
    if (!$d["function_perms"]) {
      $this->error = "ERROR:  You must enter a permissions for the method.";
      return False;	
    }
    else {
      return True;
    }
  }
  
  
  /**************************************************************************
   * name: add()
   * created by: pablo
   * description: creates a new function record
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    $hash_secret="PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if (!$this->validate_add($d)) {
      $d["error"] = $this->error;
      return False;
    }
    $q = "INSERT INTO function (function_name, function_class, ";
    $q .= "function_method, function_perms, function_description)";
    $q .= " VALUES ('";
    $q .= $d["function_name"] . "','";
    $q .= $d["function_class"] . "','";
    $q .= $d["function_method"] . "','";
    $q .= $d["function_perms"] . "','";
    $q .= $d["function_description"] . "')";
    $db->query($q);
    $db->next_record();
    return True;

  }
  
  /**************************************************************************
   * name: update()
   * created by: pablo
   * description: updates function information
   * parameters:
   * returns:
   **************************************************************************/
  function update(&$d) {
    $db = new ps_DB;
    $timestamp = time();

    if (!$this->validate_update($d)) {
      $d["error"] = $this->error;
      return False;	
    }
    $q = "UPDATE function set ";
    $q .= "function_name='" . $d["function_name"];
    $q .= "',function_class='" . $d["function_class"];
    $q .= "',function_method='" . $d["function_method"];
    $q .= "',function_perms='" . $d["function_perms"];
    $q .= "', function_description='" . $d["function_description"];
    $q .= "' WHERE function_id='" . $d["function_id"] . "'";
    $db->query($q);
    $db->next_record();
    return True;
  }

  /**************************************************************************
   * name: delete()
   * created by: pablo
   * description: Should delete a category and and categories under it.
   * parameters: 
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if (!$this->validate_delete($d)) {
      $d["error"]=$this->error;
      return False;
    }
    $q = "DELETE from function where function_id='" . $d["function_id"] . "'";
    $db->query($q);
    $db->next_record();
    return True;
  }
}


?>
