<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*
* CLASS DESCRIPTION
*                   
* ps_product_category
*
* The class is
* 
* propeties:  
* 	
* methods:
*	
*
*************************************************************************/
class ps_product_category {
  var $classname = "ps_user";
  
  /**************************************************************************
  ** name: validate_add()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_add(&$d) {
    
    if (!$d["category_name"]) {
      $d["error"] = "ERROR:  You must enter a name for the category.";
      return False;	
    }
    else {
      return True;    
    }
  }
    
  /**************************************************************************
  ** name: validate_delete()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_delete(&$d) {

    $db = new ps_DB;

    if (!$d["category_id"]) {
      $d["error"] = "ERROR:  Please select a category to delete.";
      return False;
    }

    // Check for children
    $q  = "SELECT * from category_xref where category_parent_id='";
    $q .= $d["category_id"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      $d["error"]  = "ERROR: This category has children. ";
      $d["error"] .= "Please delete children first.";
      return False;
    }

    // Check for products assigned to this category
    $q  = "SELECT * from product_category_xref where category_id='";
    $q .= $d["category_id"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      $d["error"]  = "ERROR: This category has products. ";
      $d["error"] .= "Please delete the products first.";
      return False;
    }
    return True;
  }

  /**************************************************************************
  ** name: validate_update()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_update(&$d) {
    
    if (!$d["category_name"]) {
      $d["error"] = "ERROR:  You must enter a name for the category.";
      return False;	
    }
    elseif ($d["category_id"] == $d["category_parent_id"]) {
      $d["error"] = "ERROR:  Category parent cannot be same category.";
      return False;	
    }
    else {
      return True;
    }
  }
  
  
  /**************************************************************************
  ** name: add()
  ** created by: pablo
  ** description: creates a new category record and a category_xref record
  ** with the appropriate parent and child ids
  ** parameters:
  ** returns:
  ***************************************************************************/
  function add(&$d) {
    global $ps_vendor_id;
    $hash_secret="PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
	    
    if ($this->validate_add($d)) {
      $category_id = md5(uniqid($hash_secret));
      
      $q = "INSERT INTO category (category_id, vendor_id, category_name, ";
      $q .= "category_publish, category_description, cdate, mdate) ";
      $q .= "VALUES ('";
      $q .= $category_id . "','";
      $q .= $ps_vendor_id . "','";
      $q .= $d["category_name"] . "','";
      if ($d["category_publish"] != "Y") {
	$d["category_publish"] = "N";
      }
      $q .= $d["category_publish"] . "','";
      $q .= $d["category_description"] . "','";
      $q .= $timestamp . "','";
      $q .= $timestamp . "')";
      $db->query($q);
      $db->next_record();
      
      $q = "INSERT INTO category_xref ";
      $q .= "(category_parent_id, category_child_id) ";
      $q .= "VALUES ('";
      $q .= $d["parent_category_id"] . "','";
      $q .= $category_id . "')";
      $db->query($q);
      $db->next_record();

      return $category_id;
    }
    else {
      return False;
    }

  }

  /**************************************************************************
  ** name: update()
  ** created by: pablo
  ** description: updates category information
  ** parameters:
  ** returns:
  ***************************************************************************/
  function update(&$d) {
    $db = new ps_DB;
    $timestamp = time();

    if ($this->validate_update($d)) {
      $q = "UPDATE category SET ";
      $q .= "category_id='" . $d["category_id"];
      $q .= "',category_name='" . $d["category_name"];
      if ($d["category_publish"] != "Y") {
	$d["category_publish"] = "N";
      }
      $q .= "',category_publish='" . $d["category_publish"];
      $q .= "',category_description='" . $d["category_description"];
      $q .= "', mdate='$timestamp";
      $q .= "' WHERE category_id='" . $d["category_id"] . "' ";
      $q .= "AND vendor_id='" . $d["vendor_id"] . "' ";
      $db->query($q);
      $db->next_record();
      
      /*
      ** Update category x-reference table with parent-child relationship
      */
      $q = "UPDATE category_xref SET ";
      $q .= "category_parent_id='" . $d["category_parent_id"];
      $q .= "' WHERE category_child_id='" . $d["category_id"] . "'";
      
      $db->query($q);
      $db->next_record();

      return True;
    }
    else {
      return False;	
    }
  }

  /**************************************************************************
  ** name: delete()
  ** created by: pablo
  ** description: Should delete a category and and categories under it.
  ** parameters: 
  ** returns:
  ***************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if (!$this->validate_delete($d)) {
      return False;
    }

    $q = "DELETE FROM category WHERE category_id='" . $d["category_id"] . "'";
    $db->query($q);

    $q  = "DELETE FROM category_xref ";
    $q .= "WHERE category_child_id='" . $d["category_id"] . "'";
    $db->query($q);

    return True;
  }


  /**************************************************************************
  ** name: traverse_tree_down()
  ** created by:
  ** description: It goes through the category table and establishes
  **              the category tree based on the parent-child relationships
  **              defnied in the category_xref table.
  **              This is VERY recursive...
  **
  ** parameters:
  ** returns:
  ***************************************************************************/
  function traverse_tree_down($category_id=0, $level=0) {
    global $sess,$ps_vendor_id;
    $db = new ps_DB;
    $class = "maintext";
    
    $level++;

    $q = "SELECT * from category,category_xref ";
    $q .= "WHERE category_xref.category_parent_id='";
    $q .= $category_id . "' AND ";
    $q .= "category.category_id=category_xref.category_child_id ";
    $q .= "AND category.vendor_id = $ps_vendor_id ";
    $db->query($q);
    while ($db->next_record()) {
      echo "<TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0 WIDTH=100%><TR CLASS=$class><TD>";
      for ($i=0;$i<$level;$i++) {
        echo "&nbsp;&nbsp;&nbsp;";
      }
      echo "&#095;&#095&#095;&#095;&#095&#095;|$level|&nbsp;";
      $url  = SECUREURL . "?page=admin/product_category_form";
      $url .= "&category_id=" . $db->f("category_child_id"); 
      $url .= "&category_parent_id=" . $db->f("category_parent_id");   
      echo "<A HREF=" . $sess->url($url) . ">";
      echo $db->f("category_name") . "</A>:";
      echo "&nbsp;&nbsp;" . $db->f("category_description");
      echo "</TD><TD ALIGN=right><A HREF=";
      $sess->purl(SECUREURL . "?page=admin/product_list&category_id=" . $db->f("category_child_id"));
      echo ">List Products</A>\n</TD></TR></TABLE>\n";
      $this->traverse_tree_down($db->f("category_child_id"), $level);
    }    
  }
  



  /**************************************************************************
  ** name: traverse_tree_up()
  ** created by:
  ** description: It goes through the category table and establishes
  **              the category tree based on the parent-child relationships
  **              defnied in the category_xref table.
  **              This is VERY recursive...
  ** parameters:
  ** returns:
  ***************************************************************************/
  function traverse_tree_up($category_id, $level=0) {
    global $ps_vendor_id;
    $db = new ps_DB;
    
    $level++;
    $q = "SELECT * from category, category_xref ";
    $q .= "WHERE category_xref.category_child_id=' ";
    $q .= "$category_id' AND ";
    $q .= "category.category_id=category_xref.category_parent_id ";
    $q .= "AND category.vendor_id = $ps_vendor_id ";
    $db->query($q);
    while ($db->next_record()) {
      if ($level == 1) {
	echo "<OPTION SELECTED VALUE=" . $db->f("category_child_id");
      }
      else {
	echo "<OPTION VALUE=" . $db->f("category_child_id");
      }
      echo ">" . $db->f("category_name") . "</OPTION>";

      $this->traverse_tree_up($db->f("category_parent_id"), $level);
    }    
  }

  /***************************************************************************
  ** name: list_category()
  ** created by: pablo
  ** description: list all categories and has the category with the given
  **              product_id preselected.
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_category($product_id="",$category_id="") {
    $db = new ps_DB;
    $name = "category_id";

    echo "<SELECT NAME=$name>\n";

    if ($product_id and !$category_id) {
      $q = "SELECT * from product_category_xref WHERE product_id='$product_id'";
      $db->query($q);
      $db->next_record();
      if (!$db->f("category_id")) {
        echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
      }
      $this->list_tree($db->f("category_id"));
    } elseif ($category_id) {
      $this->list_tree($category_id);
    } else {
      echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
      $this->list_tree();
    }
    
    echo "</SELECT>\n";
    
    return True;
  }
 

  /***************************************************************************
  ** name: list_parents()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_parents($category_id) {
    $db = new ps_DB;

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Please Select</OPTION>\n";
    $this->traverse_tree_up($category_id);
    echo "</SELECT>\n";    
  }
  

  /**************************************************************************
  ** name: print_child_list()
  ** created by: pablo
  ** description: creates a bulleted of the childen of this category if they 
  **              exist
  ** parameters: category_id
  ** returns:
  ***************************************************************************/
  function print_child_list($category_id) {
    global $sess,$ps_vendor_id;
    $db = new ps_DB;

    $q = "SELECT * FROM category,category_xref ";
    $q .= "WHERE category_xref.category_parent_id='$category_id' ";
    $q .= "AND category.category_id=category_xref.category_child_id ";
/* Uncomment next line when mall functionality in place */
#    $q .= "AND category.vendor_id='$ps_vendor_id' ";
    $q .= "AND category.category_publish='Y'";
    $db->query($q);
    while($db->next_record()) {
      echo "<A HREF=";
      $sess->purl(SECUREURL . "?page=shop/browse&category_id=" . $db->f("category_child_id"));
      echo ">";
      $db->p("category_name");
      echo "</A><BR>";      
    }


  }

  /**************************************************************************
  ** name: list_all()
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_all($name, $category_id) {

    $db = new ps_DB;

    $q  = "SELECT * from category_xref ";
    $q .= "WHERE category_child_id='$category_id'";
    $db->query($q);
    $db->next_record();
    $category_id=$db->f("category_parent_id");

    echo "<SELECT NAME=$name>\n";
    echo "<OPTION VALUE=\"0\">Default-Top Level</OPTION>\n";
    $this->list_tree($category_id);
    echo "</SELECT>\n";
  }
  

  /**************************************************************************
  ** name: list_tree()
  ** created by:
  ** description: Creates OPTIONS fields for a select
  ** parameters:
  ** returns:
  ***************************************************************************/
  function list_tree($category_id="", $cid=0, $level=0) {
    global $ps_vendor_id;
    $db = new ps_DB;
    
    $level++;

    $q = "SELECT * from category,category_xref ";
    $q .= "WHERE category_xref.category_parent_id='";
    $q .= $cid . "' AND ";
    $q .= "category.category_id=category_xref.category_child_id ";
    $q .= "AND category.vendor_id = $ps_vendor_id ";
    $db->query($q);

    while ($db->next_record()) {
      if ($db->f("category_child_id") != $cid) {
	if ($db->f("category_child_id") == $category_id) {
	  echo "<OPTION SELECTED VALUE=" . $db->f("category_child_id") . ">\n";
	}
	else {
	  echo "<OPTION VALUE=" . $db->f("category_child_id") . ">\n";
	}
      }
      for ($i=0;$i<$level;$i++) {
        echo "&#151";
      }
      echo "|$level|";
      echo "&nbsp;" . $db->f("category_name") . "</OPTION>";
      $this->list_tree($category_id, $db->f("category_child_id"), $level);
    }    
  }
 
  /**************************************************************************
  ** name: get_name()
  ** created by: jep
  ** description: Returns the category name.
  ** parameters:
  ** returns:
  ***************************************************************************/
  function get_name($product_id) {
    $db = new ps_DB;

    $q = "SELECT category_name FROM category,product_category_xref ";
    $q .= "WHERE product_id='$product_id' ";
    $q .= "AND category.category_id = product_category_xref.category_id ";
    $db->query($q);

    $db->next_record();

    return $db->f("category_name");
  }
}


?>
