<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*
* CLASS DESCRIPTION
*                   
* ps_class
*
* The class is
* 
* propeties:  
* 	
*       error - the error message returned by validation if any
* methods:
*       validate_add()
*	validate_delete()
*	validate_update()
*       add()
*       update()
*       delete()
*	
*
*************************************************************************/
class ps_shopper {
  var $classname = "ps_shopper";
  var $error;
  


  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_add($d) {
    
    if (!$d["last_name"]) {
      $this->error = "ERROR:  You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "ERROR:  You must enter a first name for the user.";
      return False;	
    }
    if (!$d["username"]) {
      $this->error = "ERROR:  You must enter a username for the user.";
      return False;	
    }
    if (!$d["password_1"]) {
      $this->error = "ERROR:  You must enter a password for the user.";
      return False;		
    }
    if ($d["password_1"] != $d["password_2"]) {
      $this->error = "ERROR:  The passwords entered do not match.";
      return False;		
    }
    if (!$d["user_email"]) {
      $this->error = "ERROR:  Please enter an email address.";
      return False;
    }
    if (!validate_email($d["user_email"])) {
      $this->error = "ERROR:  Please provide a valid email address.";
      return False;
    }
    $db = new ps_DB;
    $q = "SELECT * from auth_user_md5 where username='" .  $d["username"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      $this->error = "ERROR:  The given username already exists.  ";
      $this->error .= "ERROR:  Please try another username.";
      return False;
    }
    return True;
  }
  
  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_delete($d) {

    if (!$d["user_id"]) {
      $this->error = "ERROR:  Please select a user to delete.";
      return False;
    }
    else {
      return True;
    }
  }

  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/    function validate_update($d) {
    
    if (!$d["last_name"]) {
      $this->error = "ERROR:  You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "ERROR:  You must enter a first name for the user.";
      return False;	
    }
    if (!$d["username"]) {
      $this->error = "ERROR:  You must enter a username for the user.";
      return False;	
    }
    if ($d["password_1"] != $d["password_2"]) {
      $this->error = "ERROR:  The passwords entered do not match.";
      return False;		
    }
    if (!$d["user_email"]) {
      $this->error = "ERROR:  You must enter an email address.";
      return False;
    }
    if (!validate_email($d["user_email"])) {
      $this->error = "ERROR:  Please provide a valid email address.";
      return False;
    }
    return True;
  }
  
  
  /**************************************************************************
   * name: add()
   * created by:a pablo
   * description: adds a shopper to a vendor
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    global $ps_vendor_id,
           $auth;

    $hash_secret = "PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if (!$this->validate_add($d)) {
      $d["error"] = $this->error;
      return False;
    }
   
    $d["perms"] = "shopper";
 
    $user_id=md5(uniqid($hash_secret));
    
    $q = "INSERT INTO auth_user_md5 (user_id,username,password, perms) ";
    $q .= "VALUES ('";
    $q .= $user_id . "','";
    $q .= $d["username"] . "','";
    $q .= md5($d["password_1"]) . "','";
    $q .= $d["perms"] . "')";
    $db->query($q);
    $db->next_record();
    
    // Insert billto
    $q = "INSERT INTO user_info (user_id,address_type, address_type_name,";
    $q .= "company, title, last_name, first_name,middle_name,";
    $q .= "phone_1, phone_2, fax, address_1,";
    $q .= "address_2, city, state, country, zip,";
    $q .= "user_email, cdate, mdate) VALUES ";
    $q .= "('" . $user_id . "','";
    $q .= $d["address_type"] . "','";
    $q .= $d["address_type_name"] . "','";
    $q .= $d["company"] . "','";
    $q .= $d["title"] . "','";
    $q .= $d["last_name"] . "','";
    $q .= $d["first_name"] . "','";
    $q .= $d["middle_name"] . "','";
    $q .= $d["phone_1"] . "','";
    $q .= $d["phone_2"] . "','";
    $q .= $d["fax"] . "','";
    $q .= $d["address_1"] . "','";
    $q .= $d["address_2"] . "','";
    $q .= $d["city"] . "','";
    $q .= $d["state"] . "','";
    $q .= $d["country"] . "','";
    $q .= $d["zip"] . "','";
    $q .= $d["user_email"] . "','";
    $q .= time() . "','";
    $q .= time() . "') ";
    $db->query($q);
    $db->next_record();
    
    // Insert copy of billto as default shipto
    $q = "INSERT INTO user_info (user_id,address_type, address_type_name,";
    $q .= "company, title, last_name, first_name,middle_name,";
    $q .= "phone_1, phone_2, fax, address_1,";
    $q .= "address_2, city, state, country, zip,";
    $q .= "user_email, cdate, mdate) VALUES ";
    $q .= "('" . $user_id . "','";
    $q .= "ST','";
    $q .= "Default-BillTo','";
    $q .= $d["company"] . "','";
    $q .= $d["title"] . "','";
    $q .= $d["last_name"] . "','";
    $q .= $d["first_name"] . "','";
    $q .= $d["middle_name"] . "','";
    $q .= $d["phone_1"] . "','";
    $q .= $d["phone_2"] . "','";
    $q .= $d["fax"] . "','";
    $q .= $d["address_1"] . "','";
    $q .= $d["address_2"] . "','";
    $q .= $d["city"] . "','";
    $q .= $d["state"] . "','";
    $q .= $d["country"] . "','";
    $q .= $d["zip"] . "','";
    $q .= $d["user_email"] . "','";
    $q .= time() . "','";
    $q .= time() . "') ";
    $db->query($q);
    $db->next_record();

    $q = "INSERT INTO shopper_vendor_xref (user_id,vendor_id,shopper_group_id,customer_number) ";
    $q .= "VALUES ('";
    $q .= $user_id . "','";
    $q .= $ps_vendor_id . "','";
    $q .= $d["shopper_group_id"] . "','";
    $q .= $d["customer_number"] . "')";
    $db->query($q);
    $db->next_record();

    return True;
    
  }
  
  /**************************************************************************
   * name: update()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function update(&$d) {
    global $auth,
           $perm;

    $db = new ps_DB;
    $timestamp = time();
 
    /* $d["perms"] = "shopper";  */
    
    if (!$this->validate_update($d)) {
      $d["error"] = $this->error;
      return False;
    }

    if ($perm->check("shopper")) {
       // Just a shopper.  Can only update themselves
       // Limited update abilities

       $update_user_id = $auth->auth["uid"];

       if ($d["password_1"]) {
          $d["password_1"] = md5($d["password_1"]);
          $q = "UPDATE auth_user_md5 set password='" . $d["password_1"];
          $q .= "username='" . $d["username"] . "' ";
          $q .= "WHERE user_id='" . $update_user_id . "'";      
       }
       else {
          $q = "UPDATE auth_user_md5 set ";
          $q .= "username='" . $d["username"] . "' ";
          $q .= "WHERE user_id='" . $update_user_id . "'";      
       }

       $db->query($q);
       $db->next_record();

       $q = "UPDATE user_info SET ";
       $q .= "title='" . $d["title"] . "', ";
       $q .= "last_name='" . $d["last_name"] . "', ";
       $q .= "first_name='" . $d["first_name"] . "', ";
       $q .= "middle_name='" . $d["middle_name"] . "', ";
       $q .= "user_email='" . $d["user_email"] . "', ";
       $q .= "mdate='" . $timestamp . "' ";
       $q .= "WHERE user_id='" . $update_user_id . "' ";
       $q .= "AND address_type='BT'";

       $db->query($q);
       $db->next_record();
    }
    else {
       // Admin user.  Can update other shoppers (user_id specified as a 
       // GET or POST variable.
       // More extensive update abilities

       $update_user_id = $user_id;

       if ($d["password_1"]) {
          $d["password_1"] = md5($d["password_1"]);
          $q = "UPDATE auth_user_md5 set password='" . $d["password_1"];
          $q .= "username='" . $d["username"] . "', ";
          $q .= "perms='" . $d["perms"] . "' ";
          $q .= "WHERE user_id='" . $update_user_id . "'";      
       }
       else {
          $q = "UPDATE auth_user_md5 set ";
          $q .= "username='" . $d["username"] . "', ";
          $q .= "perms='" . $d["perms"] . "' ";
          $q .= "WHERE user_id='" . $update_user_id . "'";      
       }

       $db->query($q);
       $db->next_record();

       $q = "UPDATE user_info SET company='" . $d["company"] . "', ";
       $q .= "title='" . $d["title"] . "', ";
       $q .= "last_name='" . $d["last_name"] . "', ";
       $q .= "first_name='" . $d["first_name"] . "', ";
       $q .= "middle_name='" . $d["middle_name"] . "', ";
       $q .= "phone_1='" . $d["phone_1"] . "', ";
       $q .= "phone_2='" . $d["phone_2"] . "', ";
       $q .= "fax='" . $d["fax"] . "', ";
       $q .= "address_1='" . $d["address_1"] . "', ";
       $q .= "address_2='" . $d["address_2"] . "', ";
       $q .= "city='" . $d["city"] . "', ";
       $q .= "state='" . $d["state"] . "', ";
       $q .= "country='" . $d["country"] . "', ";
       $q .= "zip='" . $d["zip"] . "', ";
       $q .= "user_email='" . $d["user_email"] . "', ";
       $q .= "mdate='" . $timestamp . "' ";
       $q .= "WHERE user_id='" . $update_user_id . "' ";
       $q .= "AND address_type='BT'";

       $db->query($q);
       $db->next_record();

       // Update shopper group relationship

       $q = "UPDATE shopper_vendor_xref SET ";
       $q .= "shopper_group_id='" . $d["shopper_group_id"] . "', ";
       $q .= "customer_number='" . $d["customer_number"] . "' ";
       $q .= "WHERE user_id='" . $update_user_id . "'";
       $db->query($q);
       $db->next_record(); 
    } // if ($perm->check("shopper"))

    return True;
  }
  
  /**************************************************************************
   * name: delete()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if (!$this->validate_delete($d)) {
      $d["error"] = $this->error;
      return False;
    }

    // Delete auth_user_md5 entries    
    $q = "DELETE from auth_user_md5 where user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();

    // Delete user_info entries
    $q = "DELETE from user_info where user_id='" . $d["user_id"] . "'";
    $db->query($q);
    $db->next_record();

    // Delete shopper_vendor_xref entries
    $q = "DELETE from shopper_vendor_xref where user_id='" . $d["user_id"] . "'"; 
    $db->query($q);
    $db->next_record();
    
    return True;
  }
}

?>
