<?php
/****************************************************************************
*    Copyright (C) 2000 Edikon Corporation.
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
**************************************************************************** 
*
* CLASS DESCRIPTION
*                   
* ps_class
*
* The class is
* 
* propeties:  
* 	
*       error - the error message returned by validation if any
* methods:
*       validate_add()
*	validate_delete()
*	validate_update()
*       add()
*       update()
*       delete()
*	
*
*************************************************************************/
class ps_user_address {
  var $classname = "ps_user_address";
  var $error;
  

  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/   function validate_add($d) {
    
    if (!$d["last_name"]) {
      $this->error = "You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "You must enter a first name for the user.";
      return False;	
    }
    if (strcasecmp($d["address_type"], "BT") == 0 &&
        !$d["user_email"]) {
      $this->error = "You must enter an email address.";
      return False;
    }
    if ($d["user_email"] &&
        !validate_email($d["user_email"])) {
      $this->error = "Please provide a valid email address.";
      return False;
    } 
    $db = new ps_DB;
    $q = "SELECT * from user_info where address_type_name='" .  $d["address_type_name"] . "'";
    $q .= " AND user_id='" . $d["user_id"] . "'";
    $db->query($q);
    if ($db->next_record()) {
      $this->error = "The given address label already exists.";
      return False;
    }
    return True;    
  }
  
  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/   function validate_delete($d) {

    if (!$d["user_info_id"]) {
      $this->error = "Please select a user address to delete.";
      return False;
    }
    else {
      return True;
    }
  }

  /**************************************************************************
  ** name: validate
  ** created by:
  ** description:
  ** parameters:
  ** returns:
  ***************************************************************************/   function validate_update($d) {
    
    if (!$d["last_name"]) {
      $this->error = "You must enter a last name for the user.";
      return False;	
    }
    if (!$d["first_name"]) {
      $this->error = "You must enter a first name for the user.";
      return False;	
    }
    if (strcasecmp($d["address_type"], "BT") == 0 &&
        !$d["user_email"]) {
      $this->error = "You must enter an email address.";
      return False;
    }
    if ($d["user_email"] &&
        !validate_email($d["user_email"])) {
      $this->error = "Please provide a valid email address.";
      return False;
    } 
    return True;
  }
  
  
  /**************************************************************************
   * name: add()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function add(&$d) {
    $hash_secret = "PHPShopIsCool";
    $db = new ps_DB;
    $timestamp = time();
    
    if (!$this->validate_add($d)) {
      $vars["error"] = $this->error;
      return False;
    }
 
      $q = "INSERT INTO user_info (user_id,address_type, address_type_name,";
      $q .= "company, title, last_name, first_name,middle_name,";
      $q .= "phone_1, phone_2, fax, address_1,";
      $q .= "address_2, city, state, country, zip,";
      $q .= "user_email, cdate, mdate) VALUES ";
      
      $q .= "('" . $d["user_id"] . "','";
      $q .= $d["address_type"] . "','";
      $q .= $d["address_type_name"] . "','";
      $q .= $d["company"] . "','";
      $q .= $d["title"] . "','";
      $q .= $d["last_name"] . "','";
      $q .= $d["first_name"] . "','";
      $q .= $d["middle_name"] . "','";
      $q .= $d["phone_1"] . "','";
      $q .= $d["phone_2"] . "','";
      $q .= $d["fax"] . "','";
      $q .= $d["address_1"] . "','";
      $q .= $d["address_2"] . "','";
      $q .= $d["city"] . "','";
      $q .= $d["state"] . "','";
      $q .= $d["country"] . "','";
      $q .= $d["zip"] . "','";
      
      $q .= $d["user_email"] . "','";
      $q .= time() . "','";
      $q .= time() . "') ";
      $db->query($q);
      $db->next_record();
      return True;
  }
  
  /**************************************************************************
   * name: update()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function update(&$d) {
    $db = new ps_DB;
    $timestamp = time();
    
    if ($this->validate_update($d)) {
      $q = "UPDATE user_info set company='" . $d["company"] . "', ";
      $q .= "address_type='" . $d["address_type"] . "', ";
      $q .= "address_type_name='" . $d["address_type_name"] . "', ";
      $q .= "title='" . $d["title"] . "', ";
      $q .= "last_name='" . $d["last_name"] . "', ";
      $q .= "first_name='" . $d["first_name"] . "', ";
      $q .= "middle_name='" . $d["middle_name"] . "', ";
      $q .= "phone_1='" . $d["phone_1"] . "', ";
      $q .= "phone_2='" . $d["phone_2"] . "', ";
      $q .= "fax='" . $d["fax"] . "', ";
      $q .= "address_1='" . $d["address_1"] . "', ";
      $q .= "address_2='" . $d["address_2"] . "', ";
      $q .= "city='" . $d["city"] . "', ";
      $q .= "state='" . $d["state"] . "', ";
      $q .= "country='" . $d["country"] . "', ";
      $q .= "zip='" . $d["zip"] . "', ";
      $q .= "user_email='" . $d["user_email"] . "', ";
      $q .= "mdate='" . time() . "' ";
      $q .= "WHERE user_info_id='" . $d["user_info_id"] . "'";
      $db->query($q);
      $db->next_record();
      return True;
    }
    else {
      $d["error"] = $this->error;
      return False;
    }
  }
  
  /**************************************************************************
   * name: delete()
   * created by:
   * description:
   * parameters:
   * returns:
   **************************************************************************/
  function delete(&$d) {
    $db = new ps_DB;
    
    if ($this->validate_delete($d)) {
      $q = "DELETE from user_info where user_info_id='" . $d["user_info_id"] . "'";
      $db->query($q);
      $db->next_record();
      return True;
    }
    else {
      $d["error"] = $this->error;
      return False;
    }
  }

}

?>
